unit GLAudioHeader;

//***********************************
//***** GLAudioHeader Komponente*****
//*****   von Gnther Leitgeb   *****
//***********************************
//
//Mit dieser Komponente kann man Infos
//zu Mp3 und Wave Dateien auslesen
//
//Einfach das dazugehrige DEMOProgramm
//anssehen
//
//Rckmeldungen an: G_Leitgeb@gmx.at

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TWaveHeader=record
   Kennung_Art:array[0..3] of char;
   Laenge_Datei:DWord;
   Kennung_Format:array[0..7] of char;
   Laenge_Strucktur:DWord;
   Format_Version:Word;
   Anzahl_Kanaele:Word;
   Abtastfrequenz:DWord;
   BytesproSekunde:DWord;
   BytesproSample:Word;
   BitsproSample:Word;
   Data:array[0..3] of char;
   Laenge_Datenfeld:DWord;
  end;

  TMPEGTag=record
   Tag:array[0..2] of char;
   Titel:array[0..29] of char;
   Interpret:array[0..29] of char;
   Album:array[0..29] of char;
   Jahr:array[0..3] of char;
   Kommentar:array[0..29] of char;
   Genre:byte;
  end;

  TGLAudioHeader = class(TComponent)
  private
    FDateiname:string;
    FTitel,FInterpret,FAlbum,FJahr,FKommentar,FVersion,FLayer,FProtection,FBitrate,FFrequenz,FPadding,FStereomode,FModeextension,FCopyright,FOriginal,FEmphasis:string;
    FGenre:byte;
  protected
    { Protected-Deklarationen }
  public
    function GetHeader:boolean;
    function GetID:boolean;
    function SetID:boolean;
  published
    property Dateiname:string read FDateiname write FDateiname;
    property Titel:string read FTitel write FTitel;
    property Interpret:string read FInterpret write FInterpret;
    property Album:string read FAlbum write FAlbum;
    property Jahr:string read FJahr write FJahr;
    property Kommentar:string read FKommentar write FKommentar;
    property Genre:byte read FGenre write FGenre;
    property Version:string read FVersion write FVersion;
    property Layer:string read FLayer write FLayer;
    property Protection:string read FProtection write FProtection;
    property Bitrate:string read FBitrate write FBitrate;
    property Frequenz:string read FFrequenz write FFrequenz;
    property Padding:string read FPadding write FPadding;
    property Stereomode:string read FStereomode write FStereomode;
    property Modeextension:string read FModeextension write FModeextension;
    property Copyright:string read FCopyright write FCopyright;
    property Original:string read FOriginal write FOriginal;
    property Emphasis:string read FEmphasis write FEmphasis;
  end;

procedure Register;

const
  KGenre        :array[0..255] of string=('Blues','Classic Rock','Country','Dance','Disco','Funk','Grunge','Hip-Hop','Jazz','Metal','New Age','Oldies','Other','Pop','R&&B','Rap','Reggae','Rock','Techno','Industrial','Alternativ','Ska','Death Metal','Pranks','Soundtrack','Euro-Techno','Ambient','Trip-Hop','Vocal','Jazz+Funk','Fusion','Trance','Classical','Intrumental','Acid','House','Game','Sound Clip','Gospel','Noise','AlternRock','Bass','Soul','Punk','Space','Meditative','Instrumental Pop','Intrumental Rock','Ethnic','Gothic','Darkwave','Techno-Industrial','Electronic','Pop-Folk','Eurodance','Dream','Southern Rock','Comedy','Cult','Gangsta','Top 40','Christian Rap','Pop/Funk','Jungle','Native American','Cabaret','New Wave','Psychadelic','Rave','Showtunes','Trailer','Lo-Fi','Tribal','Acid Punk','Acid Jazz','Polka','Retro','Musical','Rock&&Roll','Hard Rock','Folk','Folk-Rock','National-Folk','Swing','Fast Fusion','Bebob','Latin','Revival','Celtic','Bluegrass','Avantgarde','Gothic Rock','Progessive Rock',
                                         'Psychedelic Rock','Symphonic Rock','Slow Rock','Big Band','Chorus','Easy Listening','Acoustic','Humour','Speech','Chanson','Opera','Chamber Music','Sonata','Symphony','Booty Brass','Primus','Porn Groove','Satire','Slow Jam','Club','Tango','Samba','Folklore','Ballad','Power Ballad','Rhytmic Soul','Freestyle','Duet','Punk Rock','Drum Solo','A Capella','Euro-House','Dance Hall','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
  KVersion      :array[0..3] of string = ('MPEG Version 2.5','Reserve','MPEG Version 2','MPEG Version 1');
  KLayer        :array[0..3] of string = ('Reserve','Layer III','Layer II','Layer I');
  KProtection   :array[0..1] of string = ('Protected by CRC','Not Protected');
  KBitrate      :array[0..15,0..3,0..3] of string = ( (('','','',''),('','','',''),('','','',''),('','','','')),
                                                      (('','8000','8000','32000'),('','','',''),('','8000','8000','32000'),('','32000','32000','32000')),
                                                      (('','16000','16000','48000'),('','','',''),('','16000','16000','48000'),('','40000','48000','64000')),
                                                      (('','24000','24000','56000'),('','','',''),('','24000','24000','56000'),('','48000','56000','96000')),
                                                      (('','32000','32000','64000'),('','','',''),('','32000','32000','64000'),('','56000','64000','128000')),
                                                      (('','40000','40000','80000'),('','','',''),('','40000','40000','80000'),('','64000','80000','160000')),
                                                      (('','48000','48000','96000'),('','','',''),('','48000','48000','96000'),('','80000','96000','192000')),
                                                      (('','56000','56000','112000'),('','','',''),('','56000','56000','112000'),('','96000','112000','224000')),
                                                      (('','64000','64000','128000'),('','','',''),('','64000','64000','128000'),('','112000','128000','256000')),
                                                      (('','80000','80000','144000'),('','','',''),('','80000','80000','144000'),('','128000','160000','288000')),
                                                      (('','96000','96000','160000'),('','','',''),('','96000','96000','160000'),('','160000','192000','320000')),
                                                      (('','112000','112000','176000'),('','','',''),('','112000','112000','176000'),('','192000','224000','352000')),
                                                      (('','128000','128000','192000'),('','','',''),('','128000','128000','192000'),('','224000','256000','384000')),
                                                      (('','144000','144000','224000'),('','','',''),('','144000','144000','224000'),('','256000','320000','416000')),
                                                      (('','160000','160000','256000'),('','','',''),('','160000','160000','256000'),('','320000','384000','448000')),
                                                      (('','','',''),('','','',''),('','','',''),('','','','')));
  KFrequenz :array[0..3,0..2] of string = (('11025','12000','8000'),('','',''),('22050','24000','16000'),('44100','48000','32000'));
  KPadding   :array[0..1] of string = ('Frame not padded','Frame is padded');
  KStereomode      :array[0..3] of string = ('Stereo','Joint Stereo','Dual channel','Mono');
  KModeextension:array[0..3,0..3] of string = (('','','Bands 4 to 31','Bands 4 to 31'),('','Intensity stereo','Bands 8 to 31','Bands 8 to 31'),('','MS stereo','Bands 12 to 31','Bands 12 to 31'),('','Intensity stereo & MS stereo','Bands 16 to 31','Bands 16 to 31'));
  KCopyright    :array[0..1] of string = ('Audio is not copyrighted','Audio is copyrighted');
  KOriginal     :array[0..1] of string = ('Kopie','Original');
  KEmphasis     :array[0..3] of string = ('None','50/15 ms','Reserve','CCIT J.17');

  KStereomodeWAV:array[1..2] of string = ('Mono','Stereo');

implementation

procedure Register;
begin
  RegisterComponents('GL Komponente', [TGLAudioHeader]);
end;

function TGLAudioHeader.GetHeader:Boolean;
var Datei:file;
    Daten1,Daten2,Daten3,Daten4:byte;
    WSync:word;
    WPrivatebit:byte;
    WVersion,WLayer,WProtection,WBitrate,WFrequenz,WPadding,WStereomode,WModeextension,WCopyright,WOriginal,WEmphasis:byte;
    Header:TWaveHeader;
    Tag:TMPEGTag;
begin
 FTitel:='';
 FInterpret:='';
 FAlbum:='';
 FJahr:='';
 FKommentar:='';
 FGenre:=0;
 FVersion:='';
 FLayer:='';
 FBitrate:='';
 FFrequenz:='';
 FStereomode:='';
 FProtection:='';
 FPadding:='';
 FCopyright:='';
 FOriginal:='';
 FEmphasis:='';

 if (lowercase(extractfileext(FDateiname))='.mp1') or (Lowercase(extractfileext(FDateiname))='.mp2') or (lowercase(extractfileext(FDateiname))='.mp3') then
 begin
  assignfile(Datei,FDateiname);
  Filemode:=0;
  reset(Datei,1);
  while not eof(Datei) do
  begin
   blockread(Datei,Daten1,sizeof(Daten1));
   blockread(Datei,Daten2,sizeof(Daten2));
   if (Daten1=$FF) and ((Daten2 and $E0)=$E0) then
   begin
    blockread(Datei,Daten3,sizeof(Daten3));
    blockread(Datei,Daten4,sizeof(Daten4));

    WSync:=0;
    if Daten1 and 128>0 then WSync := WSync or 1024;
    if Daten1 and 64>0  then WSync := WSync or 512;
    if Daten1 and 32>0  then WSync := WSync or 256;
    if Daten1 and 16>0  then WSync := WSync or 128;
    if Daten1 and 8>0   then WSync := WSync or 64;
    if Daten1 and 4>0   then WSync := WSync or 32;
    if Daten1 and 2>0   then WSync := WSync or 16;
    if Daten1 and 1>0   then WSync := WSync or 8;
    if Daten2 and 128>0 then WSync := WSync or 4;
    if Daten2 and 64>0  then WSync := WSync or 2;
    if Daten2 and 32>0  then WSync := WSync or 1;

    WVersion:=0;
    if Daten2 and 16>0  then WVersion:=WVersion or 2;
    if Daten2 and 8>0   then WVersion:=WVersion or 1;

    WLayer:=0;
    if Daten2 and 4>0   then WLayer:=WLayer or 2;
    if Daten2 and 2>0   then WLayer:=WLayer or 1;

    WProtection:=0;
    if Daten2 and 1>0   then WProtection:=WProtection or 1;

    WBitrate:=0;
    if Daten3 and 128>0 then WBitrate:=WBitrate or 8;
    if Daten3 and 64>0  then WBitrate:=WBitrate or 4;
    if Daten3 and 32>0  then WBitrate:=WBitrate or 2;
    if Daten3 and 16>0  then WBitrate:=WBitrate or 1;

    WFrequenz:=0;
    if Daten3 and 8>0   then WFrequenz:=WFrequenz or 2;
    if Daten3 and 4>0   then WFrequenz:=WFrequenz or 1;

    WPadding:=0;
    if Daten3 and 2>0   then WPadding:=WPadding or 1;

    WPrivatebit:=0;
    if Daten3 and 1>0   then WPrivatebit:=WPrivatebit or 1;

    WStereomode:=0;
    if Daten4 and 128>0 then WStereomode:=WStereomode or 2;
    if Daten4 and 64>0  then WStereomode:=WStereomode or 1;

    WModeextension:=0;
    if Daten4 and 32>0  then WModeextension:=WModeextension or 2;
    if Daten4 and 16>0  then WModeextension:=WModeextension or 1;

    WCopyright:=0;
    if Daten4 and 8>0   then WCopyright:=WCopyright or 1;

    WOriginal:=0;
    if Daten4 and 4>0   then WOriginal:=WOriginal or 1;

    WEmphasis:=0;
    if Daten4 and 2>0   then WEmphasis:=WEmphasis or 2;
    if Daten4 and 1>0   then WEmphasis:=WEmphasis or 1;

    if WSync=2047 then
    begin
     FVersion:=KVersion[WVersion];
     FLayer:=KLayer[WLayer];
     FProtection:=KProtection[WProtection];
     FBitrate:=KBitrate[WBitrate,WVersion,WLayer];
     FFrequenz:=KFrequenz[WVersion,WFrequenz];
     FPadding:=KPadding[WPadding];
     FStereomode:=KStereomode[WStereomode];
     FModeextension:=KModeextension[WModeextension,WLayer];
     FCopyright:=KCopyright[WCopyright];
     FOriginal:=KOriginal[WOriginal];
     FEmphasis:=KEmphasis[WEmphasis];
     closefile(Datei);

     GetID;

     Result:=True;
    end
    else Result:=false;
    exit;
   end;
  end;
  closefile(Datei);
 end;
 if Lowercase(extractfileext(FDateiname))='.wav' then
 begin
  assignfile(Datei,FDateiname);
  Filemode:=0;
  reset(Datei,1);
  blockread(Datei,Header,sizeof(Header));
  closefile(Datei);

  if (Header.Kennung_Art='RIFF') and (Header.Kennung_Format='WAVEfmt ') then
  begin
   FVersion:='Wave Version '+inttostr(Header.Format_Version);
   FStereomode:=KStereomodeWAV[Header.Anzahl_Kanaele];
   FFrequenz:=inttostr(Header.Abtastfrequenz)+' Hz';
   FBitrate:=inttostr(Header.BitsproSample)+' Bit';
   Result:=true;
  end
  else
  begin
  Result:=false;
  end;
 end;
end;

function TGLAudioHeader.GetID:boolean;
var Datei:file;
    Tag:TMPEGTag;
begin
 if fileexists(FDateiname) then
 begin
  assignfile(Datei,FDateiname);
  Filemode:=0;
  reset(Datei,1);
  seek(Datei,Filesize(Datei)-sizeof(Tag));
  blockread(Datei,Tag,sizeof(Tag));
  closefile(Datei);
  if Tag.Tag='TAG' then
  begin
   FTitel:=Trim(Tag.Titel);
   FInterpret:=Trim(Tag.Interpret);
   FAlbum:=Trim(Tag.Album);
   FJahr:=Trim(Tag.Jahr);
   FKommentar:=Trim(Tag.Kommentar);
   FGenre:=Tag.Genre;
   result:=true;
  end
  else
  begin
   FGenre:=255;
   result:=false;
  end;
 end
 else
 begin
  FGenre:=255;
  result:=false;
 end;
end;

function TGLAudioHeader.SetID:boolean;
var Datei:file;
    Tag:TMPEGTag;
    i:integer;
begin
 if fileexists(FDateiname) then
 begin
  assignfile(Datei,FDateiname);
  Filemode:=2;
  reset(Datei,1);
  seek(Datei,Filesize(Datei)-sizeof(Tag));
  blockread(Datei,Tag,sizeof(Tag));

  for i:=0 to 29 do
  begin
   if i<length(FTitel) then Tag.Titel[i]:=FTitel[i+1] else Tag.Titel[i]:=chr(0);
   if i<length(FInterpret) then Tag.Interpret[i]:=FInterpret[i+1] else Tag.Interpret[i]:=chr(0);
   if i<length(FAlbum) then Tag.Album[i]:=FAlbum[i+1] else Tag.Album[i]:=chr(0);
   if i<length(FKommentar) then Tag.Kommentar[i]:=FKommentar[i+1] else Tag.Kommentar[i]:=chr(0);
  end;
  for i:=0 to 3 do
  begin
   if i<length(FJahr) then Tag.Jahr[i]:=FJahr[i+1] else Tag.Jahr[i]:=chr(0);
  end;
  Tag.Genre:=FGenre;

  if Tag.Tag='TAG' then
  begin
   seek(Datei,Filesize(Datei)-sizeof(Tag));
  end
  else
  begin
   Tag.Tag:='TAG';
   seek(Datei,Filesize(Datei));
  end;

  Truncate(Datei);
  blockwrite(Datei,Tag,sizeof(Tag));
  closefile(Datei);
  result:=true;
 end
 else
 begin
  result:=false;
 end;
end;

end.
